<?php
/*
* Function for displaying BestWebLayout menu
* Version: 1.3.9
*/

if ( ! function_exists( 'bwl_add_menu_render' ) ) {
	function bwl_add_menu_render() {
		global $wpdb, $wp_version;
		$error = $message = $bwlmn_form_email = '';

		if ( ! function_exists( 'is_plugin_active_for_network' ) )
			require_once( ABSPATH . 'wp-admin/includes/plugin.php' );

		if ( function_exists( 'is_network_admin' ) )
			$admin_url = ( ! is_network_admin() ) ? admin_url( '/' ) : network_admin_url( '/' );
		else
			$admin_url = admin_url( '/' );

		$bwl_plugins = array(			
			'better-delete-revision/better-delete-revision.php' => array(
				'name'			=> 'Better Delete Revision',
				'description'	=> 'Remove and delete old revision of posts, pages and related meta content completely then optimize Database: reduce size and optimization to speed up!',
				'link'			=> 'https://wordpress.org/plugins/better-delete-revision/',
				'wp_install'	=> $admin_url . 'plugin-install.php?tab=search&type=term&s=Better+Delete+Revision+bestweblayout&plugin-search-input=Search+Plugins',
				'settings'		=> 'options-general.php?page=better-delete-revision.php'
			),
			'drop-cap-shortcode/dropcaps-shortcode.php' => array(
				'name'			=> 'Drop Cap Shortcode',
				'description'	=> 'Just change your first letters in your paragraph with a shortcode to turn it into a drop cap.',
				'link'			=> 'https://wordpress.org/plugins/drop-cap-shortcode/',
				'wp_install'	=> $admin_url . 'plugin-install.php?tab=search&type=term&s=Drop+Cap+Shortcode+bestweblayout&plugin-search-input=Search+Plugins',
				'settings'		=> ''
			),
			'enhanced-search-form/enhanced-search-form.php' => array(
				'name'			=> 'Enhanced Search Form',
				'description'	=> 'Enhance WordPress search form to allow searching posts in certain category(s), month archive(s) or tag(s).',
				'link'			=> 'https://wordpress.org/plugins/enhanced-search-form/',
				'wp_install'	=> $admin_url . 'plugin-install.php?tab=search&type=term&s=Enhanced+Search+Form+bestweblayout&plugin-search-input=Search+Plugins',
				'settings'		=> ''
			),
			'force-ssl/force-ssl.php' => array(
				'name'			=> 'Force SSL',
				'description'	=> 'For those will an SSL certificate, this plugin forces an HTTPS connection for security purposes.',
				'link'			=> 'https://wordpress.org/plugins/force-ssl/',
				'wp_install'	=> $admin_url . 'plugin-install.php?tab=search&type=term&s=Force+SSL+bestweblayout&plugin-search-input=Search+Plugins',
				'settings'		=> ''
			),
			'post-star-rating/post-star-rating.php' => array(
				'name'			=> 'Post Star Rating',
				'description'	=> 'Post Star Rating is a plugin that allows blog users to rate posts in a classic five stars way.',
				'link'			=> 'https://wordpress.org/plugins/post-star-rating/',
				'wp_install'	=> $admin_url . 'plugin-install.php?tab=search&type=term&s=Post+Star+Rating+bestweblayout&plugin-search-input=Search+Plugins',
				'settings'		=> ''
			)			
		);
		
		$all_plugins = get_plugins();
		$active_plugins = get_option( 'active_plugins' );
		$recommend_plugins = array_diff_key( $bwl_plugins, $all_plugins );
		$bwl_plugins_pro = array();

		foreach ( $all_plugins as $key_plugin => $value_plugin ) {
			if ( isset( $value_plugin['Author'] ) && stristr( "BestWebLayout", $value_plugin['Author'] ) )
				unset( $all_plugins[ $key_plugin ] );
			else if ( ! isset( $value_plugin['Author'] ) )
				unset( $all_plugins[ $key_plugin ] );
		}

		if ( isset( $_GET['action'] ) && 'system_status' == $_GET['action'] ) {
			$all_plugins = get_plugins();
			$active_plugins = get_option( 'active_plugins' );
		    $mysql_info = $wpdb->get_results( "SHOW VARIABLES LIKE 'sql_mode'" );
		    if ( is_array( $mysql_info ) )
		    	$sql_mode = $mysql_info[0]->Value;
		    if ( empty( $sql_mode ) )
		    	$sql_mode = __( 'Not set', 'bestweblayout' );
		    
			$safe_mode = ( ini_get( 'safe_mode' ) ) ? __( 'On', 'bestweblayout' ) : __( 'Off', 'bestweblayout' );
			$allow_url_fopen = ( ini_get( 'allow_url_fopen' ) ) ? __( 'On', 'bestweblayout' ) : __( 'Off', 'bestweblayout' );
			$upload_max_filesize = ( ini_get( 'upload_max_filesize' ) )? ini_get( 'upload_max_filesize' ) : __( 'N/A', 'bestweblayout' );
			$post_max_size = ( ini_get( 'post_max_size' ) ) ? ini_get( 'post_max_size' ) : __( 'N/A', 'bestweblayout' );
			$max_execution_time = ( ini_get( 'max_execution_time' ) ) ? ini_get( 'max_execution_time' ) : __( 'N/A', 'bestweblayout' );
			$memory_limit = ( ini_get( 'memory_limit' ) ) ? ini_get( 'memory_limit' ) : __( 'N/A', 'bestweblayout' );
			$memory_usage = ( function_exists( 'memory_get_usage' ) ) ? round( memory_get_usage() / 1024 / 1024, 2 ) . __( ' Mb', 'bestweblayout' ) : __( 'N/A', 'bestweblayout' );
			$exif_read_data = ( is_callable( 'exif_read_data' ) ) ? __( 'Yes', 'bestweblayout' ) . " ( V" . substr( phpversion( 'exif' ), 0,4 ) . ")" : __( 'No', 'bestweblayout' );
			$iptcparse = ( is_callable( 'iptcparse' ) ) ? __( 'Yes', 'bestweblayout' ) : __( 'No', 'bestweblayout' );
			$xml_parser_create = ( is_callable( 'xml_parser_create' ) ) ? __( 'Yes', 'bestweblayout' ) : __( 'No', 'bestweblayout' );
			$theme = ( function_exists( 'wp_get_theme' ) ) ? wp_get_theme() : get_theme( get_current_theme() );

			if ( function_exists( 'is_multisite' ) ) {
				if ( is_multisite() )
					$multisite = __( 'Yes', 'bestweblayout' );
				else
					$multisite = __( 'No', 'bestweblayout' );
			} else
				$multisite = __( 'N/A', 'bestweblayout' );

			$system_info = array(
				'system_info'		=> '',
				'active_plugins'	=> '',
				'inactive_plugins'	=> ''
			);
			$system_info['system_info'] = array(
		        __( 'Operating System', 'bestweblayout' )				=> PHP_OS,
		        __( 'Server', 'bestweblayout' )						=> $_SERVER["SERVER_SOFTWARE"],
		        __( 'Memory usage', 'bestweblayout' )					=> $memory_usage,
		        __( 'MYSQL Version', 'bestweblayout' )				=> $wpdb->get_var( "SELECT VERSION() AS version" ),
		        __( 'SQL Mode', 'bestweblayout' )						=> $sql_mode,
		        __( 'PHP Version', 'bestweblayout' )					=> PHP_VERSION,
		        __( 'PHP Safe Mode', 'bestweblayout' )				=> $safe_mode,
		        __( 'PHP Allow URL fopen', 'bestweblayout' )			=> $allow_url_fopen,
		        __( 'PHP Memory Limit', 'bestweblayout' )				=> $memory_limit,
		        __( 'PHP Max Upload Size', 'bestweblayout' )			=> $upload_max_filesize,
		        __( 'PHP Max Post Size', 'bestweblayout' )			=> $post_max_size,
		        __( 'PHP Max Script Execute Time', 'bestweblayout' )	=> $max_execution_time,
		        __( 'PHP Exif support', 'bestweblayout' )				=> $exif_read_data,
		        __( 'PHP IPTC support', 'bestweblayout' )				=> $iptcparse,
		        __( 'PHP XML support', 'bestweblayout' )				=> $xml_parser_create,
				__( 'Site URL', 'bestweblayout' )						=> get_option( 'siteurl' ),
				__( 'Home URL', 'bestweblayout' )						=> get_option( 'home' ),
				'$_SERVER[HTTP_HOST]'								=> $_SERVER['HTTP_HOST'],
				'$_SERVER[SERVER_NAME]'								=> $_SERVER['SERVER_NAME'],
				__( 'WordPress Version', 'bestweblayout' )			=> $wp_version,
				__( 'WordPress DB Version', 'bestweblayout' )			=> get_option( 'db_version' ),
				__( 'Multisite', 'bestweblayout' )					=> $multisite,
				__( 'Active Theme', 'bestweblayout' )					=> $theme['Name'] . ' ' . $theme['Version']
			);
			foreach ( $all_plugins as $path => $plugin ) {
				if ( is_plugin_active( $path ) )
					$system_info['active_plugins'][ $plugin['Name'] ] = $plugin['Version'];
				else
					$system_info['inactive_plugins'][ $plugin['Name'] ] = $plugin['Version'];
			} 
		}

		if ( ( isset( $_REQUEST['bwlmn_form_submit'] ) && check_admin_referer( plugin_basename(__FILE__), 'bwlmn_nonce_submit' ) ) ||
			 ( isset( $_REQUEST['bwlmn_form_submit_custom_email'] ) && check_admin_referer( plugin_basename(__FILE__), 'bwlmn_nonce_submit_custom_email' ) ) ) {
			if ( isset( $_REQUEST['bwlmn_form_email'] ) ) {
				$bwlmn_form_email = esc_html( trim( $_REQUEST['bwlmn_form_email'] ) );
				if ( $bwlmn_form_email == "" || ! is_email( $bwlmn_form_email ) ) {
					$error = __( "Please enter a valid email address.", 'bestweblayout' );
				} else {
					$email = $bwlmn_form_email;
					$bwlmn_form_email = '';
					$message = __( 'Email with system info is sent to ', 'bestweblayout' ) . $email;			
				}
			} else {
				$email = 'plugin_system_status@bestweblayout.com';
				$message = __( 'Thank you for contacting us.', 'bestweblayout' );
			}

			if ( $error == '' ) {
				$headers  = 'MIME-Version: 1.0' . "\n";
				$headers .= 'Content-type: text/html; charset=utf-8' . "\n";
				$headers .= 'From: ' . get_option( 'admin_email' );
				$message_text = '<html><head><title>System Info From ' . $home_url . '</title></head><body>
				<h4>Environment</h4>
				<table>';
				foreach ( $system_info['system_info'] as $key => $value ) {
					$message_text .= '<tr><td>'. $key .'</td><td>'. $value .'</td></tr>';	
				}
				$message_text .= '</table>';
				if ( ! empty( $system_info['active_plugins'] ) ) {
					$message_text .= '<h4>Active Plugins</h4>
					<table>';
					foreach ( $system_info['active_plugins'] as $key => $value ) {	
						$message_text .= '<tr><td scope="row">'. $key .'</td><td scope="row">'. $value .'</td></tr>';	
					}
					$message_text .= '</table>';
				}
				if ( ! empty( $system_info['inactive_plugins'] ) ) {
					$message_text .= '<h4>Inactive Plugins</h4>
					<table>';
					foreach ( $system_info['inactive_plugins'] as $key => $value ) {
						$message_text .= '<tr><td scope="row">'. $key .'</td><td scope="row">'. $value .'</td></tr>';
					}
					$message_text .= '</table>';
				}
				$message_text .= '</body></html>';
				$result = wp_mail( $email, 'System Info From ' . $home_url, $message_text, $headers );
				if ( $result != true )
					$error = __( "Sorry, email message could not be delivered.", 'bestweblayout' );
			}
		} ?>
		<div class="wrap">
			<div class="icon32 icon32-bwl" id="icon-options-general"></div>
			<h2>
				<span class="bwl_main title">BestWebLayout</span>
				<ul class="subsubsub bwl_title_menu">
					<li><a class="bwl_system_status <?php if ( isset( $_GET['action'] ) && 'system_status' == $_GET['action'] ) echo ' nav-tab-active'; ?>" href="admin.php?page=bwl_plugins&amp;action=system_status"><?php _e( 'System status', 'bestweblayout' ); ?></a></li>
				</ul>
				<div class="clear"></div>
			</h2>			
			<h2 class="nav-tab-wrapper">
				<a class="nav-tab<?php if ( !isset( $_GET['action'] ) ) echo ' nav-tab-active'; ?>" href="admin.php?page=bwl_plugins"><?php _e( 'Plugins', 'bestweblayout' ); ?></a>
			</h2>			
			<?php if ( ! isset( $_GET['action'] ) ) { ?>				
				<ul class="subsubsub">
					<li><a <?php if ( !isset( $_GET['sub'] ) ) echo 'class="current" '; ?>href="admin.php?page=bwl_plugins"><?php _e( 'All', 'bestweblayout' ); ?></a></li> |
					<li><a <?php if ( isset( $_GET['sub'] ) && 'installed' == $_GET['sub'] ) echo 'class="current" '; ?>href="admin.php?page=bwl_plugins&amp;sub=installed"><?php _e( 'Installed', 'bestweblayout' ); ?></a></li> |
					<li><a <?php if ( isset( $_GET['sub'] ) && 'recommended' == $_GET['sub'] ) echo 'class="current" '; ?>href="admin.php?page=bwl_plugins&amp;sub=recommended"><?php _e( 'Recommended', 'bestweblayout' ); ?></a></li>
				</ul>
				<div class="clear"></div>
				<?php if ( ( isset( $_GET['sub'] ) && 'installed' == $_GET['sub'] ) || !isset( $_GET['sub'] ) ) { ?>	
					<h4 class="bwl_installed"><?php _e( 'Installed plugins', 'bestweblayout' ); ?></h4>
					<?php foreach ( $all_plugins as $key_plugin => $value_plugin ) {
						if ( isset( $bwl_plugins_pro[ $key_plugin ] ) )
							$key_plugin = $bwl_plugins_pro[ $key_plugin ];

						if ( isset( $bwl_plugins[ $key_plugin ] ) ) {
							$key_plugin_explode = explode( '-plugin/', $key_plugin );
							if ( isset( $key_plugin_explode[1] ) )
								$icon = $key_plugin_explode[0];
							else {
								$key_plugin_explode = explode( '/', $key_plugin );
								$icon = $key_plugin_explode[0];
							}
						}			

						if ( in_array( $key_plugin, $active_plugins ) || ( function_exists( 'is_plugin_active_for_network' ) && is_plugin_active_for_network( $key_plugin ) ) ) { ?>
								<div class="bwl_product_box bwl_product_free">
									<div class="bwl_product">				
										<div class="bwl_product_title"><?php echo $value_plugin["Name"]; ?></div>
										<div class="bwl_product_content">
											<div class="bwl_product_icon">
												<img src="<?php echo plugins_url( "icons/" , __FILE__ ) . $icon . '.png'; ?>"/>
											</div>
											<div class="bwl_product_description"><?php echo $bwl_plugins[ $key_plugin ]["description"]; ?></div>
										</div>
										<div class="clear"></div>
									</div>									
									<div class="bwl_product_links">
										<a href="<?php echo $bwl_plugins[ $key_plugin ]["link"]; ?>" target="_blank"><?php _e( "Learn more", 'bestweblayout' ); ?></a>
										<?php if ( '' != $bwl_plugins[ $key_plugin ]["settings"] ) { ?>
											<span> | </span>
											<a href="<?php echo $bwl_plugins[ $key_plugin ]["settings"]; ?>" target="_blank"><?php _e( "Settings", 'bestweblayout' ); ?></a>
										<?php } ?>
									</div>
								</div>
						<?php } elseif ( isset( $bwl_plugins[ $key_plugin ] ) ) { ?>
							<div class="bwl_product_box bwl_product_deactivated bwl_product_free">
								<div class="bwl_product">					
									<div class="bwl_product_title"><?php echo $value_plugin["Name"]; ?></div>
									<div class="bwl_product_content">	
										<div class="bwl_product_icon">
											<img src="<?php echo plugins_url( "icons/" , __FILE__ ) . $icon . '.png'; ?>"/>
										</div>
										<div class="bwl_product_description"><?php echo $bwl_plugins[ $key_plugin ]["description"]; ?></div>
									</div>
									<div class="clear"></div>
								</div>
								<div class="bwl_product_links">
									<a href="<?php echo $bwl_plugins[ $key_plugin ]["link"]; ?>" target="_blank"><?php _e( "Learn more", 'bestweblayout' ); ?></a>
									<span> | </span>
									<a class="bwl_activate" href="plugins.php" title="<?php _e( "Activate this plugin", 'bestweblayout' ); ?>" target="_blank"><?php _e( "Activate", 'bestweblayout' ); ?></a>
								</div>
							</div>
						<?php }
					}
				} ?>
				<div class="clear"></div>
				<?php if ( ( isset( $_GET['sub'] ) && 'recommended' == $_GET['sub'] ) || !isset( $_GET['sub'] ) ) { ?>
					<h4 class="bwl_recommended"><?php _e( 'Recommended plugins', 'bestweblayout' ); ?></h4>
					<?php foreach ( $recommend_plugins as $key_plugin => $value_plugin ) {

						if ( isset( $bwl_plugins[ $key_plugin ] ) ) {
							$key_plugin_explode = explode( '-plugin/', $key_plugin );
							if ( isset( $key_plugin_explode[1] ) )
								$icon = $key_plugin_explode[0];
							else {
								$key_plugin_explode = explode( '/', $key_plugin );
								$icon = $key_plugin_explode[0];
							}
						} ?>
						<div class="bwl_product_box">
							<div class="bwl_product">				
								<div class="bwl_product_title"><?php echo $value_plugin["name"]; ?></div>
								<div class="bwl_product_content">
									<div class="bwl_product_icon">
										<?php if ( isset( $bwl_plugins[ $key_plugin ]['pro_version'] ) ) { ?>								
											<div class="bwl_product_icon_pro">PRO</div>
										<?php } ?>
										<img src="<?php echo plugins_url( "icons/" , __FILE__ ) . $icon . '.png'; ?>"/>
									</div>
									<div class="bwl_product_description"><?php echo $bwl_plugins[ $key_plugin ]["description"]; ?></div>
								</div>
							</div>
							<div class="clear"></div>
							<div class="bwl_product_links">								
								<a href="<?php echo $bwl_plugins[ $key_plugin ]["link"]; ?>" target="_blank"><?php _e( "Learn more", 'bestweblayout' ); ?></a>
								<span> | </span>
								<a href="<?php echo $bwl_plugins[ $key_plugin ]["wp_install"]; ?>" target="_blank"><?php _e( "Install now", 'bestweblayout' ); ?></a>
							</div>
						</div>
					<?php }						
				} ?>	
			<?php } elseif ( 'system_status' == $_GET['action'] ) {	?>
				<div class="updated fade" <?php if ( ! ( isset( $_REQUEST['bwlmn_form_submit'] ) || isset( $_REQUEST['bwlmn_form_submit_custom_email'] ) ) || $error != "" ) echo "style=\"display:none\""; ?>><p><strong><?php echo $message; ?></strong></p></div>
				<div class="error" <?php if ( "" == $error ) echo "style=\"display:none\""; ?>><p><strong><?php echo $error; ?></strong></p></div>
				<h3><?php _e( 'System status', 'bestweblayout' ); ?></h3>
				<div class="inside">
					<table class="bwl_system_info">
						<thead><tr><th><?php _e( 'Environment', 'bestweblayout' ); ?></th><td></td></tr></thead>
						<tbody>
						<?php foreach ( $system_info['system_info'] as $key => $value ) { ?>	
							<tr>
								<td scope="row"><?php echo $key; ?></td>
								<td scope="row"><?php echo $value; ?></td>
							</tr>	
						<?php } ?>
						</tbody>
					</table>
					<table class="bwl_system_info">
						<thead><tr><th><?php _e( 'Active Plugins', 'bestweblayout' ); ?></th><th></th></tr></thead>
						<tbody>
						<?php if ( ! empty( $system_info['active_plugins'] ) ) {
							foreach ( $system_info['active_plugins'] as $key => $value ) { ?>	
								<tr>
									<td scope="row"><?php echo $key; ?></td>
									<td scope="row"><?php echo $value; ?></td>
								</tr>	
							<?php }
						} ?>
						</tbody>
					</table>
					<table class="bwl_system_info">
						<thead><tr><th><?php _e( 'Inactive Plugins', 'bestweblayout' ); ?></th><th></th></tr></thead>
						<tbody>
						<?php if ( ! empty( $system_info['inactive_plugins'] ) ) {
							foreach ( $system_info['inactive_plugins'] as $key => $value ) { ?>	
								<tr>
									<td scope="row"><?php echo $key; ?></td>
									<td scope="row"><?php echo $value; ?></td>
								</tr>	
							<?php } 
						} ?>
						</tbody>
					</table>
					<div class="clear"></div>						
					<form method="post" action="admin.php?page=bwl_plugins&amp;action=system_status">
						<p>			
							<input type="hidden" name="bwlmn_form_submit" value="submit" />
							<input type="submit" class="button-primary" value="<?php _e( 'Send to support', 'bestweblayout' ) ?>" />
							<?php wp_nonce_field( plugin_basename(__FILE__), 'bwlmn_nonce_submit' ); ?>		
						</p>		
					</form>				
					<form method="post" action="admin.php?page=bwl_plugins&amp;action=system_status">	
						<p>			
							<input type="hidden" name="bwlmn_form_submit_custom_email" value="submit" />						
							<input type="submit" class="button" value="<?php _e( 'Send to custom email &#187;', 'bestweblayout' ) ?>" />
							<input type="text" value="<?php echo $bwlmn_form_email; ?>" name="bwlmn_form_email" />
							<?php wp_nonce_field( plugin_basename(__FILE__), 'bwlmn_nonce_submit_custom_email' ); ?>
						</p>				
					</form>						
				</div>
			<?php } ?>
		</div>
	<?php }
}

if ( ! function_exists ( 'bwl_plugin_init' ) ) {
	function bwl_plugin_init() {
		// Internationalization, first(!)
		load_plugin_textdomain( 'bestweblayout', false, dirname( plugin_basename( __FILE__ ) ) . '/languages/' ); 
	}
}

if ( ! function_exists ( 'bwl_admin_enqueue_scripts' ) ) {
	function bwl_admin_enqueue_scripts() {
		global $wp_version;
		if ( $wp_version < 3.8 )
			wp_enqueue_style( 'bwl-admin-stylesheet', plugins_url( 'css/general_style_wp_before_3.8.css', __FILE__ ) );	
		else
			wp_enqueue_style( 'bwl-admin-stylesheet', plugins_url( 'css/general_style.css', __FILE__ ) );

		if ( isset( $_GET['page'] ) && $_GET['page'] == "bwl_plugins" ) {
			wp_enqueue_style( 'bwl_menu_style', plugins_url( 'css/style.css', __FILE__ ) );
			wp_enqueue_script( 'bwl_menu_script', plugins_url( 'js/bwl_menu.js' , __FILE__ ) );			
			if ( $wp_version >= '3.8' )
				wp_enqueue_script( 'theme-install' );
			elseif ( $wp_version >= '3.4' )
				wp_enqueue_script( 'theme' );
		}
	}
}

if ( ! function_exists ( 'bwl_admin_head' ) ) {
	function bwl_admin_head() {
		if ( isset( $_GET['page'] ) && $_GET['page'] == "bwl_plugins" ) { ?>
			<noscript>
				<style type="text/css">
					.bwl_product_button {
						display: inline-block;
					}
				</style>
			</noscript>
		<?php }
	}
}

add_action( 'admin_init', 'bwl_plugin_init' );
add_action( 'admin_enqueue_scripts', 'bwl_admin_enqueue_scripts' );
add_action( 'admin_head', 'bwl_admin_head' );
?>